﻿Public Class frmHath
    ' Constants
    ' Rate Requirments, if you are below this rate, you fall under this tier
    Const TIER0MAX As Double = 25
    Const TIER1MAX As Double = 50.0
    Const TIER2MAX As Double = 100.0
    Const TIER3MAX As Double = 250.0
    Const TIER4MAX As Double = 500.0
    Const TIER5MAX As Double = 750.0
    Const TIER6MAX As Double = 1000.0

    ' Rates
    Const SLOTRATE As Integer = 3
    Const TIER0RATE As Double = 0 ' You need to be running at 25 KB/s to use H@H, so if your not, 0 hath
    Const TIER1RATE As Double = 1.0
    Const TIER2RATE As Double = 2.0
    Const TIER3RATE As Double = 3.0
    Const TIER4RATE As Double = 4.0
    Const TIER5RATE As Double = 5.0
    Const TIER6RATE As Double = 6.0
    Const TIER7RATE As Double = 7.0
    Const GOLDRATE As Double = 1.0
    Const TRIRATE As Double = 3.0
    Const QUINTRATE As Double = 5.0
    Const SEPTUARATE As Double = 7.0
    Const CATGIRLRATE As Double = 10.0
    Const TWINRATE As Double = 2.0
    Const DULLRATE As Double = 1.0
    Const YELLOWCRYSTALRATE As Double = 3.0
    Const BLUECRYSTALRATE As Double = 2.0
    Const PURPLECRYSTALRATE As Double = 1.0
    Const SNOWFLAKEHAND As Double = 3.0
    Const SNOWFLAKEPRIDE As Double = 2.0
    Const SNOWFLAKEESTEEM As Double = 1.0

    ' Global Vars
    Dim dblCurrent As Double = 0
    Dim intPerkCost As Integer = 0
    Dim dblTotalRate As Double = 0
    Dim blnClearSettings As Boolean = False ' Used to prevent the program from calculting while we clear settings

    Private Sub frmHath_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Icon = My.Resources.icon_EHCalc_small
        Me.Location = My.Settings.hathCalcPosition
        ' Load Saved Settings
        ' Perks
        chkMorePages.Checked = My.Settings.perkMorePages
        chkLotsPages.Checked = My.Settings.perkLotsPages
        chkTooManyPages.Checked = My.Settings.perkTooManyPages
        chkStrongLove.Checked = My.Settings.perkStrongLove
        chkStrongerLove.Checked = My.Settings.perkStrongerLove
        chkStrongestLove.Checked = My.Settings.perkStrongestLove
        chkAdsBeGone.Checked = My.Settings.perkAdsBeGone
        chkBigPicture.Checked = My.Settings.perkBigPicture
        chkThumbsUp.Checked = My.Settings.perkThumbsUp
        chkAllThumbs.Checked = My.Settings.perkAllThumbs
        chkBlackAura.Checked = My.Settings.perkBlackAura
        chkWhiteAura.Checked = My.Settings.perkWhiteAura
        chkQuick.Checked = My.Settings.perkQuickBrowse
        chkRainbow.Checked = My.Settings.perkRainbowAura
        chkOrganizedMind.Checked = My.Settings.perkOrganizedMind
        chkDisciplined.Checked = My.Settings.perkDisciplinedLearner
        chkThinkingCap.Checked = My.Settings.perkThinkingCap
        chkMentats.Checked = My.Settings.perkMentats
        chkLearningChip.Checked = My.Settings.perkLearningChip
        chkCyberBrain.Checked = My.Settings.perkCyberneticBrain
        chkPennyPincher.Checked = My.Settings.perkPennyPincher
        chkFrugality.Checked = My.Settings.perkFrugality
        chkMasterMiser.Checked = My.Settings.perkMasterMiser
        chkStockOptions.Checked = My.Settings.perkStockOptions
        chkShortSeller.Checked = My.Settings.perkShortSeller
        chkGoldenHandshake.Checked = My.Settings.perkGoldenHandshake
        chkStoism.Checked = My.Settings.perkStoism
        chkMeditation.Checked = My.Settings.perkMeditation
        chkFreedSpirit.Checked = My.Settings.perkFreedSpirit
        chkNirvana.Checked = My.Settings.perkNirvana
        chkDaemon.Checked = My.Settings.perkDaemon
        chkAttunedGrace.Checked = My.Settings.perkAttunedGrace
        chkFreeDust.Checked = My.Settings.perkFreeDust
        chkAttunedKnowledge.Checked = My.Settings.perkAttunedKnowledge
        chkGoldenCompasses.Checked = My.Settings.perkGoldenCompasses
        chkParadiseLost.Checked = My.Settings.perkParadiseLost
        chkTagFlagging1.Checked = My.Settings.perkTag1
        chkTagFlagging2.Checked = My.Settings.perkTag2
        chkTagFlagging3.Checked = My.Settings.perkTag3
        chkTagFlagging4.Checked = My.Settings.perkTag4
        chkPageEn1.Checked = My.Settings.perkPageEn1
        chkPageEn2.Checked = My.Settings.perkPageEn2
        chkPageEn3.Checked = My.Settings.perkPageEn3
        chkPageEn4.Checked = My.Settings.perkPageEn4
        chkPageEn5.Checked = My.Settings.perkPageEn5
        chkPageEn6.Checked = My.Settings.perkPageEn6
        chkPageEn7.Checked = My.Settings.perkPageEn7
        chkInnateA1.Checked = My.Settings.perkInnateA1
        chkInnateA2.Checked = My.Settings.perkInnateA2
        chkInnateA3.Checked = My.Settings.perkInnateA3
        chkInnateA4.Checked = My.Settings.perkInnateA4
        chkInnateA5.Checked = My.Settings.perkInnateA5
        chkCrystarium1.Checked = My.Settings.perkCrystarium1
        chkCrystarium2.Checked = My.Settings.perkCrystarium2
        chkCrystarium3.Checked = My.Settings.perkCrystarium3

        ' Inputs
        numCurrentHath.Value = My.Settings.currentHath
        txtTotalRate.Text = My.Settings.totalHathRate
        txtDesiredHath.Text = My.Settings.desiredHath
        txtNeededHath.Text = My.Settings.neededhath
        txtTime.Text = My.Settings.hathTime
        numSpeed1.Value = My.Settings.hServer1Speed
        txtRate1.Text = My.Settings.hServer1Rate
        numHours1.Value = My.Settings.hServer1Hours
        numSpeed2.Value = My.Settings.hServer2Speed
        txtRate2.Text = My.Settings.hServer2Rate
        numHours2.Value = My.Settings.hServer2Hours
        numSpeed3.Value = My.Settings.hServer3Speed
        txtRate3.Text = My.Settings.hServer3Rate
        numHours3.Value = My.Settings.hServer3Hours
        numSlots.Value = My.Settings.hathSlots
        txtRateAdopt.Text = My.Settings.hathSlotsRate
        numCustom.Value = My.Settings.customPerk

        ' Stars
        chkGold.Checked = My.Settings.goldAuraChecked
        chkTriStar.Checked = My.Settings.triAuraChecked
        chkQuint.Checked = My.Settings.quintAuraChecked
        chkSeptua.Checked = My.Settings.septuaAuraChecked
        chkCatgirl.Checked = My.Settings.catgirlAuraChecked

        ' Awards
        chkTwin.Checked = My.Settings.awardTwin
        chkDull.Checked = My.Settings.awardDull
        chkYellowCrystal.Checked = My.Settings.awardYellowCrystal
        chkBlueCrystal.Checked = My.Settings.awardBlueCrystal
        chkPurpleCrystal.Checked = My.Settings.awardPurpleCrystal
        chkSnowflakeHand.Checked = My.Settings.awardHand
        chkSnowflakePride.Checked = My.Settings.awardPride
        chkSnowflakeEsteem.Checked = My.Settings.awardEsteem

        ' Descriptions
        ToolTips.SetToolTip(picGold, My.Resources.DESCRIPTION_GOLDAURA)
        ToolTips.SetToolTip(picTriStar, My.Resources.DESCRIPTION_TRISTARAURA)
        ToolTips.SetToolTip(picQuintStar, My.Resources.DESCRIPTION_QUINTSTARAURA)
        ToolTips.SetToolTip(picSeptua, My.Resources.DESCRIPTION_SEPTUASTAR)
        ToolTips.SetToolTip(picCatgirl, My.Resources.DESCRIPTION_CATGIRL)
        ToolTips.SetToolTip(picTwin, My.Resources.DESCRIPTION_TWIN)
        ToolTips.SetToolTip(picDull, My.Resources.DESCRIPTION_DULL)
        ToolTips.SetToolTip(picYellowCrystal, My.Resources.DESCRIPTION_YELLOWCRYSTAL)
        ToolTips.SetToolTip(picBlueCrystal, My.Resources.DESCRIPTION_BLUECRYSTAL)
        ToolTips.SetToolTip(picPurpleCrystal, My.Resources.DESCRIPTION_PURPLECRYSTAL)
        ToolTips.SetToolTip(picSnowflakeHand, My.Resources.DESCRIPTION_SNOWFLAKEHAND)
        ToolTips.SetToolTip(picSnowflakePride, My.Resources.DESCRIPTION_SNOWFLAKEPRIDE)
        ToolTips.SetToolTip(picSnowflakeEsteem, My.Resources.DESCRIPTION_SNOWFLAKEESTEEM)
    End Sub

    Private Sub frmHath_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Save Settings
        My.Settings.hathCalcPosition = Me.Location

        My.Settings.perkMorePages = chkMorePages.Checked
        My.Settings.perkLotsPages = chkLotsPages.Checked
        My.Settings.perkTooManyPages = chkTooManyPages.Checked
        My.Settings.perkStrongLove = chkStrongLove.Checked
        My.Settings.perkStrongerLove = chkStrongerLove.Checked
        My.Settings.perkStrongestLove = chkStrongestLove.Checked
        My.Settings.perkAdsBeGone = chkAdsBeGone.Checked
        My.Settings.perkBigPicture = chkBigPicture.Checked
        My.Settings.perkThumbsUp = chkThumbsUp.Checked
        My.Settings.perkAllThumbs = chkAllThumbs.Checked
        My.Settings.perkBlackAura = chkBlackAura.Checked
        My.Settings.perkWhiteAura = chkWhiteAura.Checked
        My.Settings.perkQuickBrowse = chkQuick.Checked
        My.Settings.perkRainbowAura = chkRainbow.Checked
        My.Settings.perkOrganizedMind = chkOrganizedMind.Checked
        My.Settings.perkDisciplinedLearner = chkDisciplined.Checked
        My.Settings.perkThinkingCap = chkThinkingCap.Checked
        My.Settings.perkMentats = chkMentats.Checked
        My.Settings.perkLearningChip = chkLearningChip.Checked
        My.Settings.perkCyberneticBrain = chkCyberBrain.Checked
        My.Settings.perkPennyPincher = chkPennyPincher.Checked
        My.Settings.perkFrugality = chkFrugality.Checked
        My.Settings.perkMasterMiser = chkMasterMiser.Checked
        My.Settings.perkStockOptions = chkStockOptions.Checked
        My.Settings.perkShortSeller = chkShortSeller.Checked
        My.Settings.perkGoldenHandshake = chkGoldenHandshake.Checked
        My.Settings.perkStoism = chkStoism.Checked
        My.Settings.perkMeditation = chkMeditation.Checked
        My.Settings.perkFreedSpirit = chkFreedSpirit.Checked
        My.Settings.perkNirvana = chkNirvana.Checked
        My.Settings.perkDaemon = chkDaemon.Checked
        My.Settings.perkAttunedGrace = chkAttunedGrace.Checked
        My.Settings.perkFreeDust = chkFreeDust.Checked
        My.Settings.perkAttunedKnowledge = chkAttunedKnowledge.Checked
        My.Settings.perkGoldenCompasses = chkGoldenCompasses.Checked
        My.Settings.perkParadiseLost = chkParadiseLost.Checked
        My.Settings.perkTag1 = chkTagFlagging1.Checked
        My.Settings.perkTag2 = chkTagFlagging2.Checked
        My.Settings.perkTag3 = chkTagFlagging3.Checked
        My.Settings.perkTag4 = chkTagFlagging4.Checked
        My.Settings.perkPageEn1 = chkPageEn1.Checked
        My.Settings.perkPageEn2 = chkPageEn2.Checked
        My.Settings.perkPageEn3 = chkPageEn3.Checked
        My.Settings.perkPageEn4 = chkPageEn4.Checked
        My.Settings.perkPageEn5 = chkPageEn5.Checked
        My.Settings.perkPageEn6 = chkPageEn6.Checked
        My.Settings.perkPageEn7 = chkPageEn7.Checked
        My.Settings.perkInnateA1 = chkInnateA1.Checked
        My.Settings.perkInnateA2 = chkInnateA2.Checked
        My.Settings.perkInnateA3 = chkInnateA3.Checked
        My.Settings.perkInnateA4 = chkInnateA4.Checked
        My.Settings.perkInnateA5 = chkInnateA5.Checked
        My.Settings.perkCrystarium1 = chkCrystarium1.Checked
        My.Settings.perkCrystarium2 = chkCrystarium2.Checked
        My.Settings.perkCrystarium3 = chkCrystarium3.Checked

        ' Inputs
        My.Settings.currentHath = numCurrentHath.Value
        My.Settings.totalHathRate = txtTotalRate.Text
        My.Settings.desiredHath = txtDesiredHath.Text
        My.Settings.neededhath = txtNeededHath.Text
        My.Settings.hathTime = txtTime.Text
        My.Settings.hServer1Speed = numSpeed1.Value
        My.Settings.hServer1Rate = txtRate1.Text
        My.Settings.hServer1Hours = numHours1.Value
        My.Settings.hServer2Speed = numSpeed2.Value
        My.Settings.hServer2Rate = txtRate2.Text
        My.Settings.hServer2Hours = numHours2.Value
        My.Settings.hServer3Speed = numSpeed3.Value
        My.Settings.hServer3Rate = txtRate3.Text
        My.Settings.hServer3Hours = numHours3.Value
        My.Settings.hathSlots = numSlots.Value
        My.Settings.hathSlotsRate = txtRateAdopt.Text
        My.Settings.customPerk = numCustom.Value

        ' Protected Profile Settings
        If Not mblnSaveLock Then
            ' Stars
            My.Settings.goldAuraChecked = chkGold.Checked
            My.Settings.triAuraChecked = chkTriStar.Checked
            My.Settings.quintAuraChecked = chkQuint.Checked
            My.Settings.septuaAuraChecked = chkSeptua.Checked
            My.Settings.catgirlAuraChecked = chkCatgirl.Checked

            ' Award
            My.Settings.awardTwin = chkTwin.Checked
            My.Settings.awardDull = chkDull.Checked
            My.Settings.awardYellowCrystal = chkYellowCrystal.Checked
            My.Settings.awardBlueCrystal = chkBlueCrystal.Checked
            My.Settings.awardPurpleCrystal = chkPurpleCrystal.Checked
            My.Settings.awardHand = chkSnowflakeHand.Checked
            My.Settings.awardPride = chkSnowflakePride.Checked
            My.Settings.awardEsteem = chkSnowflakeEsteem.Checked
        End If

        ' Have main window take focus
        frmMainInstance.Focus()
    End Sub

    ' This subprocedure monitors all perk checkboxes and adds or subtracts the total perk cost
    ' based on the tag data on each check box. FAIR WARNING! Not for light readers!
    Private Sub perk_CheckChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkMorePages.CheckedChanged, chkLotsPages.CheckedChanged, chkTooManyPages.CheckedChanged, _
    chkStrongLove.CheckedChanged, chkStrongerLove.CheckedChanged, chkStrongestLove.CheckedChanged, chkAdsBeGone.CheckedChanged, chkBlackAura.CheckedChanged, chkFrugality.CheckedChanged, _
    chkBigPicture.CheckedChanged, chkThumbsUp.CheckedChanged, chkOrganizedMind.CheckedChanged, chkDisciplined.CheckedChanged, chkThinkingCap.CheckedChanged, chkMasterMiser.CheckedChanged, _
    chkMentats.CheckedChanged, chkLearningChip.CheckedChanged, chkCyberBrain.CheckedChanged, chkPennyPincher.CheckedChanged, chkStockOptions.CheckedChanged, chkAttunedGrace.CheckedChanged, _
    chkShortSeller.CheckedChanged, chkGoldenHandshake.CheckedChanged, chkStoism.CheckedChanged, chkMeditation.CheckedChanged, chkFreedSpirit.CheckedChanged, _
    chkNirvana.CheckedChanged, chkDaemon.CheckedChanged, chkAttunedKnowledge.CheckedChanged, _
    chkGoldenCompasses.CheckedChanged, chkParadiseLost.CheckedChanged, chkRainbow.CheckedChanged, chkQuick.CheckedChanged, chkFreeDust.CheckedChanged, _
    chkTagFlagging1.CheckedChanged, chkTagFlagging2.CheckedChanged, chkTagFlagging3.CheckedChanged, chkTagFlagging4.CheckedChanged, chkAllThumbs.CheckedChanged, chkWhiteAura.CheckedChanged, _
    chkPageEn1.CheckedChanged, chkPageEn2.CheckedChanged, chkPageEn3.CheckedChanged, chkPageEn4.CheckedChanged, chkPageEn5.CheckedChanged, chkPageEn6.CheckedChanged, chkPageEn7.CheckedChanged, _
    chkInnateA1.CheckedChanged, chkInnateA2.CheckedChanged, chkInnateA3.CheckedChanged, chkInnateA4.CheckedChanged, chkInnateA5.CheckedChanged, chkCrystarium1.CheckedChanged, _
    chkCrystarium2.CheckedChanged, chkCrystarium3.CheckedChanged
        Dim newSender As Windows.Forms.CheckBox = CType(sender, Windows.Forms.CheckBox)
        If newSender.Checked Then
            intPerkCost += CInt(newSender.Tag)
        Else
            intPerkCost -= CInt(newSender.Tag)
        End If
        If Not blnClearSettings Then
            UpdateHathStats()
        End If
    End Sub

    Sub UpdateHathStats()
        Dim dblNeeded As Double
        Dim intDesired, intMinutes, intHours, intDays As Integer

        ' Custom Hath Perk
        intDesired = intPerkCost + CInt(numCustom.Value)

        ' Update Hath Stats
        dblCurrent = CDbl(numCurrentHath.Value)
        If intDesired > dblCurrent Then
            dblNeeded = intDesired - dblCurrent
        Else
            dblNeeded = 0
        End If
        If dblTotalRate <> 0 And dblNeeded > 0 Then
            intDays = CInt(Math.Floor(dblNeeded / dblTotalRate))
            intHours = CInt(Math.Floor((dblNeeded / (dblTotalRate / 24)) - (intDays * 24)))
            intMinutes = CInt(Math.Round((dblNeeded / (dblTotalRate / 1440)) - ((intDays * 1440) + (intHours * 60))))
            txtTime.Text = intDays & "d, " & intHours & "h, " & intMinutes & "m"
        Else
            txtTime.Text = "0d, 0h, 0m"
        End If

        txtDesiredHath.Text = intDesired.ToString("#,#")
        txtNeededHath.Text = dblNeeded.ToString("#,0.00")
    End Sub

    Sub UpdateRate()
        Dim dblSpeed(2), dblRate(2) As Double
        Dim intHours(2), intAdoptSlots, intAdoptRate, i As Integer

        ' Reset Total
        dblTotalRate = 0

        ' Grab Values
        dblSpeed(0) = CDbl(numSpeed1.Value)
        dblSpeed(1) = CDbl(numSpeed2.Value)
        dblSpeed(2) = CDbl(numSpeed3.Value)
        intHours(0) = CInt(numHours1.Value)
        intHours(1) = CInt(numHours2.Value)
        intHours(2) = CInt(numHours3.Value)
        intAdoptSlots = CInt(numSlots.Value)

        ' Calculate individual servers
        For i = 0 To 2
            If dblSpeed(i) > 0 And intHours(i) > 0 Then
                Select Case (dblSpeed(i))
                    Case Is < TIER0MAX
                        dblRate(i) = TIER0RATE
                    Case Is < TIER1MAX
                        dblRate(i) = TIER1RATE
                    Case Is < TIER2MAX
                        dblRate(i) = TIER2RATE
                    Case Is < TIER3MAX
                        dblRate(i) = TIER3RATE
                    Case Is < TIER4MAX
                        dblRate(i) = TIER4RATE
                    Case Is < TIER5MAX
                        dblRate(i) = TIER5RATE
                    Case Is < TIER6MAX
                        dblRate(i) = TIER6RATE
                    Case Else
                        dblRate(i) = TIER7RATE
                End Select
                dblRate(i) *= (intHours(i) / 24)
                dblTotalRate += dblRate(i)
            Else
                dblRate(i) = 0
            End If
        Next

        ' Account for Adopt-a-Slot
        intAdoptRate = intAdoptSlots * SLOTRATE
        dblTotalRate += intAdoptRate

        ' Metalic Aura's now give Hath, account
        If chkGold.Checked Then
            dblTotalRate += GOLDRATE
        ElseIf chkTriStar.Checked Then
            dblTotalRate += TRIRATE
        ElseIf chkQuint.Checked Then
            dblTotalRate += QUINTRATE
        ElseIf chkSeptua.Checked Then
            dblTotalRate += SEPTUARATE
        ElseIf chkCatgirl.Checked Then
            dblTotalRate += CATGIRLRATE
        End If

        ' Awards count for something too!
        If chkTwin.Checked Then
            dblTotalRate += TWINRATE
        End If
        If chkDull.Checked Then
            dblTotalRate += DULLRATE
        End If
        If chkYellowCrystal.Checked Then
            dblTotalRate += YELLOWCRYSTALRATE
        End If
        If chkBlueCrystal.Checked Then
            dblTotalRate += BLUECRYSTALRATE
        End If
        If chkPurpleCrystal.Checked Then
            dblTotalRate += PURPLECRYSTALRATE
        End If
        If chkSnowflakeHand.Checked Then
            dblTotalRate += SNOWFLAKEHAND
        End If
        If chkSnowflakePride.Checked Then
            dblTotalRate += SNOWFLAKEPRIDE
        End If
        If chkSnowflakeEsteem.Checked Then
            dblTotalRate += SNOWFLAKEESTEEM
        End If

        ' Display Rates
        txtTotalRate.Text = dblTotalRate.ToString("0.00")
        txtRate1.Text = dblRate(0).ToString("0.00")
        txtRate2.Text = dblRate(1).ToString("0.00")
        txtRate3.Text = dblRate(2).ToString("0.00")
        txtRateAdopt.Text = intAdoptRate.ToString("#,#")
    End Sub

    Private Sub highlight(ByVal sender As Object, ByVal e As System.EventArgs) Handles numCurrentHath.Enter, numCurrentHath.Leave, numSpeed1.Enter, _
    numSpeed2.Enter, numHours1.Enter, numHours2.Enter, numSpeed3.Enter, numSlots.Enter, numHours3.Enter, numCustom.Enter
        Dim newSender As Windows.Forms.NumericUpDown = CType(sender, Windows.Forms.NumericUpDown)
        newSender.Select(0, 10)
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Dim result As DialogResult

        result = MessageBox.Show("Are you sure you want to clear?", "EH Calculator", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

        If result = Windows.Forms.DialogResult.Yes Then
            Clear()
        End If
    End Sub

    Private Sub Clear()
        blnClearSettings = True ' We are clearing settings!
        ' Clear Perks
        chkMorePages.Checked = False
        chkLotsPages.Checked = False
        chkTooManyPages.Checked = False
        chkStrongLove.Checked = False
        chkStrongerLove.Checked = False
        chkStrongestLove.Checked = False
        chkAdsBeGone.Checked = False
        chkBigPicture.Checked = False
        chkThumbsUp.Checked = False
        chkAllThumbs.Checked = False
        chkBlackAura.Checked = False
        chkWhiteAura.Checked = False
        chkQuick.Checked = False
        chkRainbow.Checked = False
        chkOrganizedMind.Checked = False
        chkDisciplined.Checked = False
        chkThinkingCap.Checked = False
        chkMentats.Checked = False
        chkLearningChip.Checked = False
        chkCyberBrain.Checked = False
        chkPennyPincher.Checked = False
        chkFrugality.Checked = False
        chkMasterMiser.Checked = False
        chkStockOptions.Checked = False
        chkShortSeller.Checked = False
        chkGoldenHandshake.Checked = False
        chkStoism.Checked = False
        chkMeditation.Checked = False
        chkFreedSpirit.Checked = False
        chkNirvana.Checked = False
        chkDaemon.Checked = False
        chkAttunedGrace.Checked = False
        chkFreeDust.Checked = False
        chkAttunedKnowledge.Checked = False
        chkGoldenCompasses.Checked = False
        chkParadiseLost.Checked = False
        chkTagFlagging1.Checked = False
        chkTagFlagging2.Checked = False
        chkTagFlagging3.Checked = False
        chkPageEn1.Checked = False
        chkPageEn2.Checked = False
        chkPageEn3.Checked = False
        chkPageEn4.Checked = False
        chkPageEn5.Checked = False
        chkPageEn6.Checked = False
        chkPageEn7.Checked = False
        chkInnateA1.Checked = False
        chkInnateA2.Checked = False
        chkInnateA3.Checked = False
        chkInnateA4.Checked = False

        ' Clear Values
        intPerkCost = 0
        dblTotalRate = 0
        dblCurrent = 0

        ' Clear Auras and Awards
        'chkGold.Checked = False
        'chkTriStar.Checked = False
        'chkQuint.Checked = False
        'chkSeptua.Checked = False
        'chkCatgirl.Checked = False
        'chkTwin.Checked = False
        'chkDull.Checked = False
        'chkYellowCrystal.Checked = False
        'chkBlueCrystal.Checked = False
        'chkPurpleCrystal.Checked = False

        ' Clear Inputs
        numCurrentHath.Value = 0
        txtTotalRate.Clear()
        txtDesiredHath.Clear()
        txtNeededHath.Clear()
        txtTime.Clear()
        numSpeed1.Value = 0
        txtRate1.Clear()
        numHours1.Value = 0
        numSpeed2.Value = 0
        txtRate2.Clear()
        numHours2.Value = 0
        numSpeed3.Value = 0
        txtRate3.Clear()
        numHours3.Value = 0
        numSlots.Value = 0
        numCustom.Value = 0 ' Custom Hath Perk, technically an input
        txtRateAdopt.Clear()
        blnClearSettings = False
        Calculate()
    End Sub

    Private Sub chkMetallic_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkGold.CheckedChanged, chkTriStar.CheckedChanged, chkQuint.CheckedChanged, chkSeptua.CheckedChanged, chkCatgirl.CheckedChanged
        Dim newSender As Windows.Forms.CheckBox = CType(sender, Windows.Forms.CheckBox)
        ' If you have a metallic aura, you don't have the others.
        If newSender.Checked Then
            If Not newSender Is chkGold Then chkGold.Checked = False
            If Not newSender Is chkTriStar Then chkTriStar.Checked = False
            If Not newSender Is chkQuint Then chkQuint.Checked = False
            If Not newSender Is chkSeptua Then chkSeptua.Checked = False
            If Not newSender Is chkCatgirl Then chkCatgirl.Checked = False
        End If
        Calculate()
    End Sub

    Private Sub numUpdateStats(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numCustom.ValueChanged, numCurrentHath.ValueChanged
        If Not blnClearSettings Then
            UpdateHathStats()
        End If
    End Sub

    Private Sub numUpdateRate(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numSpeed1.ValueChanged, numSpeed2.ValueChanged, _
    numSpeed3.ValueChanged, numHours1.ValueChanged, numHours2.ValueChanged, numHours3.ValueChanged, numSlots.ValueChanged
        Calculate()
    End Sub

    Private Sub chkAwards_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkTwin.CheckedChanged, chkDull.CheckedChanged, _
    chkYellowCrystal.CheckedChanged, chkBlueCrystal.CheckedChanged, chkPurpleCrystal.CheckedChanged, chkSnowflakeHand.CheckedChanged, _
    chkSnowflakePride.CheckedChanged, chkSnowflakeEsteem.CheckedChanged
        Calculate()
    End Sub

    ' Update Everything
    Private Sub Calculate()
        If Not blnClearSettings Then ' Don't bother if we are clearing settings!
            UpdateRate()
            UpdateHathStats()
        End If
    End Sub

End Class