﻿Public Class frmProfile

    Private Sub frmProfile_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Form Icon
        Me.Icon = My.Resources.icon_EHCalc_small

        ' Tooltips
        ToolTips.SetToolTip(picRed, My.Resources.DESCRIPTION_REDAURA)
        ToolTips.SetToolTip(picOrange, My.Resources.DESCRIPTION_ORANGEAURA)
        ToolTips.SetToolTip(picYellow, My.Resources.DESCRIPTION_YELLOWAURA)
        ToolTips.SetToolTip(picGreen, My.Resources.DESCRIPTION_GREENAURA)
        ToolTips.SetToolTip(picBlue, My.Resources.DESCRIPTION_BLUEAURA)
        ToolTips.SetToolTip(picIndigo, My.Resources.DESCRIPTION_INDIGOAURA)
        ToolTips.SetToolTip(picViolet, My.Resources.DESCRIPTION_VIOLETAURA)
        ToolTips.SetToolTip(picBlack, My.Resources.DESCRIPTION_BLACKAURA)
        ToolTips.SetToolTip(picWhite, My.Resources.DESCRIPTION_WHITEAURA)
        ToolTips.SetToolTip(picRainbow, My.Resources.DESCRIPTION_RAINBOWAURA)
        ToolTips.SetToolTip(picBronze, My.Resources.DESCRIPTION_BRONZEAURA)
        ToolTips.SetToolTip(picSilver, My.Resources.DESCRIPTION_SILVERAURA)
        ToolTips.SetToolTip(picGold, My.Resources.DESCRIPTION_GOLDAURA)
        ToolTips.SetToolTip(picTriStar, My.Resources.DESCRIPTION_TRISTARAURA)
        ToolTips.SetToolTip(picQuintStar, My.Resources.DESCRIPTION_QUINTSTARAURA)
        ToolTips.SetToolTip(picSeptua, My.Resources.DESCRIPTION_SEPTUASTAR)
        ToolTips.SetToolTip(picCatgirl, My.Resources.DESCRIPTION_CATGIRL)
        ToolTips.SetToolTip(picCookie, My.Resources.DESCRIPTION_COOKIE)
        ToolTips.SetToolTip(picTwin, My.Resources.DESCRIPTION_TWIN)
        ToolTips.SetToolTip(picDull, My.Resources.DESCRIPTION_DULL)
        ToolTips.SetToolTip(picGoldenAt, My.Resources.DESCRIPTION_GOLDENAT)
        ToolTips.SetToolTip(picYellowCrystal, My.Resources.DESCRIPTION_YELLOWCRYSTAL)
        ToolTips.SetToolTip(picBlueCrystal, My.Resources.DESCRIPTION_BLUECRYSTAL)
        ToolTips.SetToolTip(picPurpleCrystal, My.Resources.DESCRIPTION_PURPLECRYSTAL)
        ToolTips.SetToolTip(picSnowflakeHand, My.Resources.DESCRIPTION_SNOWFLAKEHAND)
        ToolTips.SetToolTip(picSnowflakePride, My.Resources.DESCRIPTION_SNOWFLAKEPRIDE)
        ToolTips.SetToolTip(picSnowflakeEsteem, My.Resources.DESCRIPTION_SNOWFLAKEESTEEM)

        ' Load Settings
        ' Profile
        dateRegistered.Value = My.Settings.dateReg
        numPosts.Value = My.Settings.postCount
        numAvgPost.Value = My.Settings.numAvgPost
        numLevel.Value = My.Settings.henjutsuLevel
        ' Auras
        chkRed.Checked = My.Settings.redAuraChecked
        chkOrange.Checked = My.Settings.orangeAuraChecked
        chkYellow.Checked = My.Settings.yellowAuraChecked
        chkGreen.Checked = My.Settings.greenAuraChecked
        chkBlue.Checked = My.Settings.blueAuraChecked
        chkIndigo.Checked = My.Settings.indigoAuraChecked
        chkViolet.Checked = My.Settings.violetAuraChecked
        chkBlack.Checked = My.Settings.blackAuraChecked
        chkWhite.Checked = My.Settings.whiteAuraChecked
        chkRainbow.Checked = My.Settings.rainbowAuraChecked
        chkBronze.Checked = My.Settings.bronzeAuraChecked
        chkSilver.Checked = My.Settings.silverAuraChecked
        chkGold.Checked = My.Settings.goldAuraChecked
        chkTriStar.Checked = My.Settings.triAuraChecked
        chkQuint.Checked = My.Settings.quintAuraChecked
        chkSeptua.Checked = My.Settings.septuaAuraChecked
        chkCatgirl.Checked = My.Settings.catgirlAuraChecked
        ' Awards
        chkCookie.Checked = My.Settings.awardCookie
        chkTwin.Checked = My.Settings.awardTwin
        chkDull.Checked = My.Settings.awardDull
        chkGoldenAt.Checked = My.Settings.awardGoldenAt
        chkYellowCrystal.Checked = My.Settings.awardYellowCrystal
        chkBlueCrystal.Checked = My.Settings.awardBlueCrystal
        chkPurpleCrystal.Checked = My.Settings.awardPurpleCrystal
        chkSnowflakeHand.Checked = My.Settings.awardHand
        chkSnowflakePride.Checked = My.Settings.awardPride
        chkSnowflakeEsteem.Checked = My.Settings.awardEsteem
        ' Perks
        cboCreditPerk.SelectedIndex = My.Settings.creditPerk
        cboExpPerk.SelectedIndex = My.Settings.expPerk
        ' Toplist
        numGallery.Value = My.Settings.toplistGallery
        numUploader.Value = My.Settings.toplistUploader
        numTagging.Value = My.Settings.toplistTagging
        numHath.Value = My.Settings.toplistHath
        numEHTracker.Value = My.Settings.toplistEHTracker
        numCleanup.Value = My.Settings.toplistCleanup
        numReviewer.Value = My.Settings.toplistReviewer
        ' Abilities
        numExpPlus.Value = My.Settings.expSkills
        numAbsorb.Value = My.Settings.numAbsorb
        numSparkofLife.Value = My.Settings.numSparkofLife
        numHaste.Value = My.Settings.haste
        numShadowVeil.Value = My.Settings.shadowVeil
        numSpiritShield.Value = My.Settings.spiritShield
        numHPTank.Value = My.Settings.hptank
        numMPTank.Value = My.Settings.mptank
        numSPTank.Value = My.Settings.sptank
        numOCTank.Value = My.Settings.octank
        ' Training
        numPowerTank.Value = My.Settings.powerTank
        numAdeptLearner.Value = My.Settings.adeptLearner
        numMiscPosting.Value = My.Settings.miscPosting

        chkLock.Checked = mblnSaveLock
    End Sub

    ' Save Changes to the rest of the calculator
    Private Sub SaveChanges()
        ' Profile
        My.Settings.dateReg = dateRegistered.Value
        My.Settings.postCount = numPosts.Value
        My.Settings.numAvgPost = numAvgPost.Value
        My.Settings.henjutsuLevel = numLevel.Value

        ' Auras
        My.Settings.redAuraChecked = chkRed.Checked
        My.Settings.orangeAuraChecked = chkOrange.Checked
        My.Settings.yellowAuraChecked = chkYellow.Checked
        My.Settings.greenAuraChecked = chkGreen.Checked
        My.Settings.blueAuraChecked = chkBlue.Checked
        My.Settings.indigoAuraChecked = chkIndigo.Checked
        My.Settings.violetAuraChecked = chkViolet.Checked
        My.Settings.blackAuraChecked = chkBlack.Checked
        My.Settings.whiteAuraChecked = chkWhite.Checked
        My.Settings.rainbowAuraChecked = chkRainbow.Checked
        My.Settings.bronzeAuraChecked = chkBronze.Checked
        My.Settings.silverAuraChecked = chkSilver.Checked
        My.Settings.goldAuraChecked = chkGold.Checked
        My.Settings.triAuraChecked = chkTriStar.Checked
        My.Settings.quintAuraChecked = chkQuint.Checked
        My.Settings.septuaAuraChecked = chkSeptua.Checked
        My.Settings.catgirlAuraChecked = chkCatgirl.Checked

        ' Awards
        My.Settings.awardCookie = chkCookie.Checked
        My.Settings.awardTwin = chkTwin.Checked
        My.Settings.awardDull = chkDull.Checked
        My.Settings.awardGoldenAt = chkGoldenAt.Checked
        My.Settings.awardYellowCrystal = chkYellowCrystal.Checked
        My.Settings.awardBlueCrystal = chkBlueCrystal.Checked
        My.Settings.awardPurpleCrystal = chkPurpleCrystal.Checked
        My.Settings.awardHand = chkSnowflakeHand.Checked
        My.Settings.awardPride = chkSnowflakePride.Checked
        My.Settings.awardEsteem = chkSnowflakeEsteem.Checked

        ' Perks
        ' Validate Combo Boxes First!
        Dim intSelected As Integer
        intSelected = cboCreditPerk.SelectedIndex
        If intSelected < 0 Or intSelected > MODE_GOLDENHANDSHAKE Then
            cboCreditPerk.SelectedIndex = 0
        End If
        My.Settings.creditPerk = cboCreditPerk.SelectedIndex

        intSelected = cboExpPerk.SelectedIndex
        If intSelected < 0 Or intSelected > MODE_CYBERNETICBRAIN Then
            cboExpPerk.SelectedIndex = 0
        End If
        My.Settings.expPerk = cboExpPerk.SelectedIndex

        ' Toplist
        My.Settings.toplistGallery = numGallery.Value
        My.Settings.toplistUploader = numUploader.Value
        My.Settings.toplistTagging = numTagging.Value
        My.Settings.toplistHath = numHath.Value
        My.Settings.toplistEHTracker = numEHTracker.Value
        My.Settings.toplistCleanup = numCleanup.Value
        My.Settings.toplistReviewer = numReviewer.Value

        ' Abilities
        My.Settings.expSkills = numExpPlus.Value
        My.Settings.numAbsorb = numAbsorb.Value
        My.Settings.numSparkofLife = numSparkofLife.Value
        My.Settings.haste = numHaste.Value
        My.Settings.shadowVeil = numShadowVeil.Value
        My.Settings.spiritShield = numSparkofLife.Value
        My.Settings.hptank = numHPTank.Value
        My.Settings.mptank = numMPTank.Value
        My.Settings.sptank = numSPTank.Value
        My.Settings.octank = numOCTank.Value

        ' Training
        My.Settings.powerTank = numPowerTank.Value
        My.Settings.adeptLearner = numAdeptLearner.Value
        My.Settings.miscPosting = numMiscPosting.Value

        mblnSaveLock = chkLock.Checked
    End Sub

    Private Sub frmProfile_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Have main window take focus
        frmMainInstance.Focus()
    End Sub

    Private Sub lblCP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblCP.Click
        openWebBrowser("http://forums.e-hentai.org/index.php?act=UserCP&CODE=00")
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        SaveChanges()
        Me.Close()
    End Sub

    Private Sub numberUpDown_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles numAbsorb.Enter, numExpPlus.Enter, _
    numPosts.Enter, numSparkofLife.Enter, numLevel.Enter, numAvgPost.Enter, numAdeptLearner.Enter, numPowerTank.Enter, numMPTank.Enter, _
    numOCTank.Enter, numSPTank.Enter, numOCTank.Enter, numHaste.Enter, numShadowVeil.Enter, numReviewer.Enter
        Dim newSender As Windows.Forms.NumericUpDown = CType(sender, Windows.Forms.NumericUpDown)
        newSender.Select(0, 10)
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Clear()
    End Sub

    Private Sub Clear()
        ' Profile
        'dateRegistered.Value = Date.Parse("1/1/2007")
        numPosts.Value = 0
        numAvgPost.Value = 0
        ' Auras
        chkRed.Checked = False
        chkOrange.Checked = False
        chkYellow.Checked = False
        chkBlue.Checked = False
        chkGreen.Checked = False
        chkIndigo.Checked = False
        chkViolet.Checked = False
        chkBlack.Checked = False
        chkWhite.Checked = False
        chkRainbow.Checked = False
        ' Stars
        chkBronze.Checked = False
        chkSilver.Checked = False
        chkGold.Checked = False
        chkTriStar.Checked = False
        chkQuint.Checked = False
        chkSeptua.Checked = False
        chkCatgirl.Checked = False
        ' Awards
        chkCookie.Checked = False
        chkTwin.Checked = False
        chkDull.Checked = False
        chkGoldenAt.Checked = False
        chkBlueCrystal.Checked = False
        chkYellowCrystal.Checked = False
        chkPurpleCrystal.Checked = False
        ' Abilities
        numExpPlus.Value = 0
        numAbsorb.Value = 0
        numSparkofLife.Value = 0
        numHaste.Value = 0
        numShadowVeil.Value = 0
        numHPTank.Value = 0
        numMPTank.Value = 0
        numSPTank.Value = 0
        ' Toplists
        numGallery.Value = 0
        numTagging.Value = 0
        numUploader.Value = 0
        numHath.Value = 0
        numCleanup.Value = 0
        numEHTracker.Value = 0
        numReviewer.Value = 0
        ' Perks
        cboCreditPerk.SelectedIndex = 0
        cboExpPerk.SelectedIndex = 0
    End Sub

    Private Sub chkMetallic_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkBronze.CheckedChanged, chkSilver.CheckedChanged, chkGold.CheckedChanged, _
chkTriStar.CheckedChanged, chkQuint.CheckedChanged, chkSeptua.CheckedChanged, chkCatgirl.CheckedChanged
        Dim newSender As Windows.Forms.CheckBox = CType(sender, Windows.Forms.CheckBox)
        ' If you have a metallic aura, you don't have the others.
        If newSender.Checked Then
            If Not newSender Is chkBronze Then chkBronze.Checked = False
            If Not newSender Is chkSilver Then chkSilver.Checked = False
            If Not newSender Is chkGold Then chkGold.Checked = False
            If Not newSender Is chkTriStar Then chkTriStar.Checked = False
            If Not newSender Is chkQuint Then chkQuint.Checked = False
            If Not newSender Is chkSeptua Then chkSeptua.Checked = False
            If Not newSender Is chkCatgirl Then chkCatgirl.Checked = False
        End If
    End Sub
End Class