﻿Public Class frmEHTrack
    ' Constants
    Const LOGBASE As Double = 1.4159265

    Private Sub btnCalc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalc.Click
        Dim dblGP, dblSize As Double
        Dim intCompletions As Integer

        dblSize = CDbl(numSize.Value)
        intCompletions = CInt(numCompletions.Value)
        If dblSize <= 0 Then
            MsgBox("Size must be greater than 0!", MsgBoxStyle.Critical)
            Return
        End If

        If intCompletions <= 0 Then
            MsgBox("Completions must be greater than 0", MsgBoxStyle.Critical)
            Return
        End If

        dblGP = (Math.Log(dblSize) / Math.Log(LOGBASE)) * intCompletions

        ' If you own both, 2x the award!
        If rdoBoth.Checked Then
            dblGP *= 2
        End If

        dblGP = Math.Round(dblGP, 2)
        txtGP.Text = dblGP.ToString("#,#.##")

    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub highlight(ByVal sender As Object, ByVal e As System.EventArgs) Handles numSize.Enter, numCompletions.Enter
        Dim newSender As Windows.Forms.NumericUpDown = CType(sender, Windows.Forms.NumericUpDown)
        newSender.Select(0, 10)
    End Sub

    Private Sub frmEHTrack_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Location = My.Settings.ehTrackerPosition
        Me.Icon = My.Resources.icon_EHCalc_small
    End Sub

    Private Sub frmEHTrack_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        My.Settings.ehTrackerPosition = Me.Location

        ' Have main window take focus
        frmMainInstance.Focus()
    End Sub
End Class