﻿Public Class frmKarma
    ' Constants
    Const MINKT1 As Integer = 10000
    Const MINKT2 As Integer = 5000
    Const MINKT3 As Integer = 2500
    Const MINKT4 As Integer = 1000
    Const MINKT5 As Integer = 500
    Const MINKT6 As Integer = 100
    Const MINKT8 As Integer = 100
    Const MINKT9 As Integer = 500
    Const MINKT10 As Integer = 1000
    Const MINKT11 As Integer = 2500
    Const MINKT12 As Integer = 5000
    Const MINKT13 As Integer = 10000
    Const MINKT14 As Integer = 25000
    Const MINKT15 As Integer = 50000
    Const MINKT16 As Integer = 75000
    Const MINKT17 As Integer = 100000
    Const MINKT18 As Integer = 150000
    Const MINKT19 As Integer = 200000
    Const MINKT20 As Integer = 300000
    Const MINKT21 As Integer = 500000
    Const MINKT22 As Integer = 800000
    Const MINKT23 As Integer = 1300000
    Const MINKT24 As Integer = 2000000
    Const MINKT25 As Integer = 4000000
    Const MINKT26 As Integer = 7000000
    Const MINKT27 As Integer = 10000000
    Const RATIOKT1 As Double = -7.0
    Const RATIOKT2 As Double = -6.0
    Const RATIOKT3 As Double = -5.0
    Const RATIOKT4 As Double = -4.0
    Const RATIOKT5 As Double = -3.0
    Const RATIOKT6 As Double = -2.0
    Const RATIOKT8 As Double = 2.0
    Const RATIOKT9 As Double = 3.0
    Const RATIOKT10 As Double = 4.0
    Const RATIOKT11 As Double = 5.0
    Const RATIOKT12 As Double = 6.0
    Const RATIOKT13 As Double = 7.0
    Const RATIOKT14 As Double = 8.0
    Const RATIOKT15 As Double = 9.0
    Const RATIOKT16 As Double = 10.0
    Const RATIOKT17 As Double = 15.0
    Const RATIOKT18 As Double = 20.0
    Const RATIOKT19 As Double = 25.0
    Const RATIOKT20 As Double = 30.0
    Const RATIOKT21 As Double = 35.0
    Const RATIOKT22 As Double = 40.0
    Const RATIOKT23 As Double = 45.0
    Const RATIOKT24 As Double = 50.0
    Const RATIOKT25 As Double = 55.0
    Const RATIOKT26 As Double = 60.0
    Const RATIOKT27 As Double = 75.0

    Dim EXPUNGEPOWERMINS() As Integer = {0, 1, 3, 5, 7, 11, 16, 23, 33, 45, 61, 79, 102, 129, 160, 195, 236, 281, _
                                     330, 385, 445, 509, 578, 652, 730, 813, 899, 1046, 1360, 1768, 2298, _
                                     2988, 3884, 5049, 6563, 8532}

    ' Used to save power for other forms.
    Dim decPower As Decimal

    Private Sub frmKarma_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Icon = My.Resources.icon_EHCalc_small
        Me.Location = My.Settings.karmaToolPosition

        ' Tooltips
        ToolTips.SetToolTip(picRed, My.Resources.DESCRIPTION_REDAURA)
        ToolTips.SetToolTip(picOrange, My.Resources.DESCRIPTION_ORANGEAURA)
        ToolTips.SetToolTip(picYellow, My.Resources.DESCRIPTION_YELLOWAURA)
        ToolTips.SetToolTip(picGreen, My.Resources.DESCRIPTION_GREENAURA)
        ToolTips.SetToolTip(picBlue, My.Resources.DESCRIPTION_BLUEAURA)
        ToolTips.SetToolTip(picIndigo, My.Resources.DESCRIPTION_INDIGOAURA)
        ToolTips.SetToolTip(picViolet, My.Resources.DESCRIPTION_VIOLETAURA)
        ToolTips.SetToolTip(picBlack, My.Resources.DESCRIPTION_BLACKAURA)
        ToolTips.SetToolTip(picWhite, My.Resources.DESCRIPTION_WHITEAURA)
        ToolTips.SetToolTip(picRainbow, My.Resources.DESCRIPTION_RAINBOWAURA)
        ToolTips.SetToolTip(picBronze, My.Resources.DESCRIPTION_BRONZEAURA)
        ToolTips.SetToolTip(picSilver, My.Resources.DESCRIPTION_SILVERAURA)
        ToolTips.SetToolTip(picGold, My.Resources.DESCRIPTION_GOLDAURA)
        ToolTips.SetToolTip(picTriStar, My.Resources.DESCRIPTION_TRISTARAURA)
        ToolTips.SetToolTip(picQuintStar, My.Resources.DESCRIPTION_QUINTSTARAURA)
        ToolTips.SetToolTip(picSeptua, My.Resources.DESCRIPTION_SEPTUASTAR)
        ToolTips.SetToolTip(picCatgirl, My.Resources.DESCRIPTION_CATGIRL)
        ToolTips.SetToolTip(picCookie, My.Resources.DESCRIPTION_COOKIE)
        ToolTips.SetToolTip(picTwin, My.Resources.DESCRIPTION_TWIN)
        ToolTips.SetToolTip(picDull, My.Resources.DESCRIPTION_DULL)
        ToolTips.SetToolTip(picGoldenAt, My.Resources.DESCRIPTION_GOLDENAT)
        ToolTips.SetToolTip(picYellowCrystal, My.Resources.DESCRIPTION_YELLOWCRYSTAL)
        ToolTips.SetToolTip(picBlueCrystal, My.Resources.DESCRIPTION_BLUECRYSTAL)
        ToolTips.SetToolTip(picPurpleCrystal, My.Resources.DESCRIPTION_PURPLECRYSTAL)

        ' Load Karma Specific Settings
        LoadKarmaSettings()

        Dim tsDefaultSpan As TimeSpan
        Dim dateDefault As Date = Date.Parse("1/1/2007")
        tsDefaultSpan = My.Settings.dateReg.Subtract(dateDefault)

        If tsDefaultSpan.TotalHours > 1 Then
            ' We have saved settings, recalculate them
            Calculate()
        Else
            ' Set up default Karma and Power Stuff
            picKarmaBar.Image = My.Resources.karma_lv_7
            lblKtName.Text = My.Resources.KT7
            txtKt.Text = "7"
            txtMultiplier.Text = "1.0"
            dateToday.Value = Now
        End If
    End Sub

    Private Sub frmKarma_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Save settings
        My.Settings.karmaToolPosition = Me.Location

        If Not mblnSaveLock Then ' Protected Profile Settings
            My.Settings.redAuraChecked = chkRed.Checked
            My.Settings.orangeAuraChecked = chkOrange.Checked
            My.Settings.yellowAuraChecked = chkYellow.Checked
            My.Settings.greenAuraChecked = chkGreen.Checked
            My.Settings.blueAuraChecked = chkBlue.Checked
            My.Settings.indigoAuraChecked = chkIndigo.Checked
            My.Settings.violetAuraChecked = chkViolet.Checked
            My.Settings.blackAuraChecked = chkBlack.Checked
            My.Settings.whiteAuraChecked = chkWhite.Checked
            My.Settings.rainbowAuraChecked = chkRainbow.Checked
            My.Settings.bronzeAuraChecked = chkBronze.Checked
            My.Settings.silverAuraChecked = chkSilver.Checked
            My.Settings.goldAuraChecked = chkGold.Checked
            My.Settings.triAuraChecked = chkTriStar.Checked
            My.Settings.quintAuraChecked = chkQuint.Checked
            My.Settings.septuaAuraChecked = chkSeptua.Checked
            My.Settings.catgirlAuraChecked = chkCatgirl.Checked
            My.Settings.postCount = numPosts.Value
            My.Settings.henjutsuLevel = numLevel.Value
            My.Settings.awardCookie = chkCookie.Checked
            My.Settings.awardTwin = chkTwin.Checked
            My.Settings.awardDull = chkDull.Checked
            My.Settings.awardGoldenAt = chkGoldenAt.Checked
            My.Settings.awardYellowCrystal = chkYellowCrystal.Checked
            My.Settings.awardBlueCrystal = chkBlueCrystal.Checked
            My.Settings.awardPurpleCrystal = chkPurpleCrystal.Checked
            My.Settings.powerTank = numPTank.Value
        End If
        My.Settings.negKarma = numNeg.Value
        My.Settings.posKarma = numPos.Value
        My.Settings.numPower = decPower

        ' Have main window take focus
        frmMainInstance.Focus()
    End Sub

    Private Sub LoadKarmaSettings()
        ' Load Saved Settings
        chkRed.Checked = My.Settings.redAuraChecked
        chkOrange.Checked = My.Settings.orangeAuraChecked
        chkYellow.Checked = My.Settings.yellowAuraChecked
        chkGreen.Checked = My.Settings.greenAuraChecked
        chkBlue.Checked = My.Settings.blueAuraChecked
        chkIndigo.Checked = My.Settings.indigoAuraChecked
        chkViolet.Checked = My.Settings.violetAuraChecked
        chkBlack.Checked = My.Settings.blackAuraChecked
        chkWhite.Checked = My.Settings.whiteAuraChecked
        chkRainbow.Checked = My.Settings.rainbowAuraChecked
        chkBronze.Checked = My.Settings.bronzeAuraChecked
        chkSilver.Checked = My.Settings.silverAuraChecked
        chkGold.Checked = My.Settings.goldAuraChecked
        chkTriStar.Checked = My.Settings.triAuraChecked
        chkQuint.Checked = My.Settings.quintAuraChecked
        chkSeptua.Checked = My.Settings.septuaAuraChecked
        chkCatgirl.Checked = My.Settings.catgirlAuraChecked
        chkCookie.Checked = My.Settings.awardCookie
        chkTwin.Checked = My.Settings.awardTwin
        chkDull.Checked = My.Settings.awardDull
        chkGoldenAt.Checked = My.Settings.awardGoldenAt
        chkYellowCrystal.Checked = My.Settings.awardYellowCrystal
        chkBlueCrystal.Checked = My.Settings.awardBlueCrystal
        chkPurpleCrystal.Checked = My.Settings.awardPurpleCrystal
        numNeg.Value = My.Settings.negKarma
        numPos.Value = My.Settings.posKarma
        numPTank.Value = My.Settings.powerTank
        numPosts.Value = My.Settings.postCount
        numLevel.Value = My.Settings.henjutsuLevel
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub chkMetallic_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkBronze.CheckedChanged, chkSilver.CheckedChanged, chkGold.CheckedChanged, _
    chkTriStar.CheckedChanged, chkQuint.CheckedChanged, chkSeptua.CheckedChanged, chkCatgirl.CheckedChanged
        ' If you have a metallic aura, you don't have the others.
        Dim newSender As Windows.Forms.CheckBox = CType(sender, Windows.Forms.CheckBox)
        ' If you have a metallic aura, you don't have the others.
        If newSender.Checked Then
            If Not newSender Is chkBronze Then chkBronze.Checked = False
            If Not newSender Is chkSilver Then chkSilver.Checked = False
            If Not newSender Is chkGold Then chkGold.Checked = False
            If Not newSender Is chkTriStar Then chkTriStar.Checked = False
            If Not newSender Is chkQuint Then chkQuint.Checked = False
            If Not newSender Is chkSeptua Then chkSeptua.Checked = False
            If Not newSender Is chkCatgirl Then chkCatgirl.Checked = False
        End If
    End Sub

    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
        Calculate()
    End Sub

    ' This subprocedure is the main brains of this tool; it does most if not all the calculations
    Private Sub Calculate()
        ' Variables
        Dim intNeg, intPos, intSeconds, intPosts, intLevel, intPTank, intKt, intPower, intExpunge As Integer
        Dim dblAuras, dblMultiplier, dblRatio, dblPower As Double
        Dim strKt As String
        Dim imgKt As Image
        Dim tsTimeSpan As TimeSpan

        ' Grab our Variables
        intNeg = CInt(numNeg.Value)
        intPos = CInt(numPos.Value)
        intPosts = CInt(numPosts.Value)
        intLevel = CInt(numLevel.Value)
        intPTank = CInt(numPTank.Value)
        ' If they somehow pull of getting a 0 here, we could be introuble
        ' Sanity Check!
        If intNeg < 1 Then
            MsgBox("WTF Did you DO? Min Value for Negative was 1, how did you get it below 1?", MsgBoxStyle.Critical)
            Return
        End If
        If intPos < 1 Then
            MsgBox("WTF Did you DO? Min Value for Positive was 1, how did you get it below 1?", MsgBoxStyle.Critical)
            Return
        End If
        tsTimeSpan = dateToday.Value.Subtract(My.Settings.dateReg)
        intSeconds = CInt(tsTimeSpan.TotalSeconds)
        If intSeconds < 0 Then
            MsgBox("You cannot be registered in the future! Please fix your date registered.", MsgBoxStyle.Critical)
            Return
        End If

        ' We have our variables, now lets calculate stuff!
        ' Calculate PK Ratio
        If intPos < intNeg Then
            dblRatio = -1.0 * CDbl(intNeg / intPos)
        Else
            dblRatio = CDbl(intPos / intNeg)
        End If

        ' Calculate Kt
        If dblRatio <= RATIOKT1 And intNeg >= MINKT1 Then
            intKt = 1
            strKt = My.Resources.KT1
            imgKt = My.Resources.karma_lv_1
        ElseIf dblRatio <= RATIOKT2 And intNeg >= MINKT2 Then
            intKt = 2
            strKt = My.Resources.KT2
            imgKt = My.Resources.karma_lv_2
        ElseIf dblRatio <= RATIOKT3 And intNeg >= MINKT3 Then
            intKt = 3
            strKt = My.Resources.KT3
            imgKt = My.Resources.karma_lv_3
        ElseIf dblRatio <= RATIOKT4 And intNeg >= MINKT4 Then
            intKt = 4
            strKt = My.Resources.KT4
            imgKt = My.Resources.karma_lv_4
        ElseIf dblRatio <= RATIOKT5 And intNeg >= MINKT5 Then
            intKt = 5
            strKt = My.Resources.KT5
            imgKt = My.Resources.karma_lv_5
        ElseIf dblRatio <= RATIOKT6 And intNeg >= MINKT6 Then
            intKt = 6
            strKt = My.Resources.KT6
            imgKt = My.Resources.karma_lv_6
        ElseIf dblRatio >= RATIOKT27 And intPos >= MINKT27 Then
            intKt = 27
            strKt = My.Resources.KT27
            imgKt = My.Resources.karma_lv_27
        ElseIf dblRatio >= RATIOKT26 And intPos >= MINKT26 Then
            intKt = 26
            strKt = My.Resources.KT26
            imgKt = My.Resources.karma_lv_26
        ElseIf dblRatio >= RATIOKT25 And intPos >= MINKT25 Then
            intKt = 25
            strKt = My.Resources.KT25
            imgKt = My.Resources.karma_lv_25
        ElseIf dblRatio >= RATIOKT24 And intPos >= MINKT24 Then
            intKt = 24
            strKt = My.Resources.KT24
            imgKt = My.Resources.karma_lv_24
        ElseIf dblRatio >= RATIOKT23 And intPos >= MINKT23 Then
            intKt = 23
            strKt = My.Resources.KT23
            imgKt = My.Resources.karma_lv_23
        ElseIf dblRatio >= RATIOKT22 And intPos >= MINKT22 Then
            intKt = 22
            strKt = My.Resources.KT22
            imgKt = My.Resources.karma_lv_22
        ElseIf dblRatio >= RATIOKT21 And intPos >= MINKT21 Then
            intKt = 21
            strKt = My.Resources.KT21
            imgKt = My.Resources.karma_lv_21
        ElseIf dblRatio >= RATIOKT20 And intPos >= MINKT20 Then
            intKt = 20
            strKt = My.Resources.KT20
            imgKt = My.Resources.karma_lv_20
        ElseIf dblRatio >= RATIOKT19 And intPos >= MINKT19 Then
            intKt = 19
            strKt = My.Resources.KT19
            imgKt = My.Resources.karma_lv_19
        ElseIf dblRatio >= RATIOKT18 And intPos >= MINKT18 Then
            intKt = 18
            strKt = My.Resources.KT18
            imgKt = My.Resources.karma_lv_18
        ElseIf dblRatio >= RATIOKT17 And intPos >= MINKT17 Then
            intKt = 17
            strKt = My.Resources.KT17
            imgKt = My.Resources.karma_lv_17
        ElseIf dblRatio >= RATIOKT16 And intPos >= MINKT16 Then
            intKt = 16
            strKt = My.Resources.KT16
            imgKt = My.Resources.karma_lv_16
        ElseIf dblRatio >= RATIOKT15 And intPos >= MINKT15 Then
            intKt = 15
            strKt = My.Resources.KT15
            imgKt = My.Resources.karma_lv_15
        ElseIf dblRatio >= RATIOKT14 And intPos >= MINKT14 Then
            intKt = 14
            strKt = My.Resources.KT14
            imgKt = My.Resources.karma_lv_14
        ElseIf dblRatio >= RATIOKT13 And intPos >= MINKT13 Then
            intKt = 13
            strKt = My.Resources.KT13
            imgKt = My.Resources.karma_lv_13
        ElseIf dblRatio >= RATIOKT12 And intPos >= MINKT12 Then
            intKt = 12
            strKt = My.Resources.KT12
            imgKt = My.Resources.karma_lv_12
        ElseIf dblRatio >= RATIOKT11 And intPos >= MINKT11 Then
            intKt = 11
            strKt = My.Resources.KT11
            imgKt = My.Resources.karma_lv_11
        ElseIf dblRatio >= RATIOKT10 And intPos >= MINKT10 Then
            intKt = 10
            strKt = My.Resources.KT10
            imgKt = My.Resources.karma_lv_10
        ElseIf dblRatio >= RATIOKT9 And intPos >= MINKT9 Then
            intKt = 9
            strKt = My.Resources.KT9
            imgKt = My.Resources.karma_lv_9
        ElseIf dblRatio >= RATIOKT8 And intPos >= MINKT8 Then
            intKt = 8
            strKt = My.Resources.KT8
            imgKt = My.Resources.karma_lv_8
        Else
            intKt = 7
            strKt = My.Resources.KT7
            imgKt = My.Resources.karma_lv_7
        End If

        ' Gah, we now have our Kt, let's get our Auras
        dblAuras = 1.0
        If chkRed.Checked Then
            dblAuras += PMOD_REDAURA
        End If
        If chkOrange.Checked Then
            dblAuras += PMOD_ORANGEAURA
        End If
        If chkYellow.Checked Then
            dblAuras += PMOD_YELLOWAURA
        End If
        If chkGreen.Checked Then
            dblAuras += PMOD_GREENAURA
        End If
        If chkBlue.Checked Then
            dblAuras += PMOD_BLUEAURA
        End If
        If chkIndigo.Checked Then
            dblAuras += PMOD_INDIGOAURA
        End If
        If chkViolet.Checked Then
            dblAuras += PMOD_VIOLETAURA
        End If
        If chkBlack.Checked Then
            dblAuras += PMOD_BLACKAURA
        End If
        If chkWhite.Checked Then
            dblAuras += PMOD_WHITEAURA
        End If
        If chkRainbow.Checked Then
            dblAuras += PMOD_RAINBOWAURA
        End If
        If chkBronze.Checked Then
            dblAuras += PMOD_BRONZEAURA
        End If
        If chkSilver.Checked Then
            dblAuras += PMOD_SILVERAURA
        End If
        If chkGold.Checked Then
            dblAuras += PMOD_GOLDAURA
        End If
        If chkTriStar.Checked Then
            dblAuras += PMOD_TRIAURA
        End If
        If chkSeptua.Checked Then
            dblAuras += PMOD_SEPTUAAURA
        End If
        If chkCatgirl.Checked Then
            dblAuras += PMOD_CATGIRLAURA
        End If
        If chkQuint.Checked Then
            dblAuras += PMOD_QUINTAURA
        End If
        If chkCookie.Checked Then
            dblAuras += PMOD_COOKIE
        End If
        If chkTwin.Checked Then
            dblAuras += PMOD_TWIN
        End If
        If chkDull.Checked Then
            dblAuras += PMOD_DULL
        End If
        If chkYellowCrystal.Checked Then
            dblAuras += PMOD_YELLOWCRYSTAL
        End If
        If chkBlueCrystal.Checked Then
            dblAuras += PMOD_BLUECRYSTAL
        End If
        If chkPurpleCrystal.Checked Then
            dblAuras += PMOD_PURPLECRYSTAL
        End If

        ' Calculate Multiplier
        dblMultiplier = (intKt - 1) * (1 / 6) * dblAuras

        ' Calculate Power with the Multiplier
        ' 10 points per year (365 days), thus use 0.0274 a day
        dblPower = Math.Round((1 + (intSeconds / 3153600) + (intPosts / 500) + (intLevel / 3) + (intPTank / 2)) * dblMultiplier, 2)
        intPower = CInt(Math.Floor(dblPower))

        If dblPower < 1 Then
            ' Power is always atleast 1
            dblPower = 1.0
        End If

        ' Update global Power for use in saving settings
        decPower = CDec(intPower)

        ' Figure out our Expunge Power
        intExpunge = 0
        Dim i As Integer = 0
        While True
            If intPower < EXPUNGEPOWERMINS(i) Then
                intExpunge = i - 1
                Exit While
            End If
            i += 1
            If i > EXPUNGEPOWERMINS.GetUpperBound(0) Then
                intExpunge = i - 1
                Exit While
            End If
        End While

        ' Update Dialog
        txtPower.Text = intPower.ToString()
        ToolTips.SetToolTip(txtPower, dblPower.ToString("0.00"))
        ToolTips.SetToolTip(lblPowerTotal, dblPower.ToString("0.00"))
        lblKtName.Text = strKt
        txtKt.Text = CStr(intKt)
        picKarmaBar.Image = imgKt
        txtMultiplier.Text = CStr(Math.Round(dblMultiplier, 3))
        txtPNRatio.Text = dblRatio.ToString("#.0")
        ToolTips.SetToolTip(txtPNRatio, CStr(Math.Round(dblRatio, 3)))
        txtDays.Text = tsTimeSpan.TotalDays.ToString("#.#")
        txtExpungePower.Text = CStr(intExpunge)
    End Sub

    Private Sub highlight(ByVal sender As Object, ByVal e As System.EventArgs) Handles numNeg.Enter, numPos.Enter, numLevel.Enter, numPosts.Enter, numPTank.Enter
        Dim newSender As Windows.Forms.NumericUpDown = CType(sender, Windows.Forms.NumericUpDown)
        newSender.Select(0, 7)
    End Sub

    Private Sub btnProfile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProfile.Click
        Dim frmMyProfile As New frmProfile
        ' Unlike other Dialogs, we do not want other stuff going on while this is open!
        frmMyProfile.ShowDialog()
        frmMyProfile = Nothing
        ' Now that we are done, update Karma settings
        LoadKarmaSettings()
    End Sub
End Class