﻿Public Class frmTraining
    ' Constants
    ' Base Costs
    Const MISC_BASE As Integer = 5000
    Const ADEPT_BASE As Integer = 50
    Const KAMP_BASE As Integer = 100
    Const PTANK_BASE As Integer = 2000
    Const ABILITY_BASE As Integer = 500
    Const SETCOLLECTOR_BASE As Integer = 12500
    Const PACKRAT_BASE As Integer = 20000
    Const RAURA_BASE As Integer = 25000
    Const SCAV_BASE As Integer = 500
    Const LUCK_BASE As Integer = 1000
    Const QUARTER_BASE As Integer = 2000
    Const ARCH_BASE As Integer = 3000
    Const SPEL_BASE As Integer = 20000
    Const ASS_BASE As Integer = 50000

    ' Cost Multiplier
    Const MISC_COST As Integer = 100
    Const ADEPT_COST As Integer = 10
    Const KAMP_COST As Integer = 25
    Const PTANK_COST As Integer = 1000
    Const ABILITY_COST As Integer = 100
    Const SETCOLLECTOR_COST As Integer = 12500
    Const PACKRAT_COST As Integer = 20000
    Const RAURA_COST As Integer = 25000
    Const SCAV_COST As Integer = 200
    Const LUCK_COST As Integer = 1000
    Const QUARTER_COST As Integer = 1500
    Const ARCH_COST As Integer = 2000
    Const SPEL_COST As Integer = 20000
    Const ASS_COST As Integer = 50000

    ' EXP Values
    Const MISC_EXP As Double = 0.0280232009
    Const ADEPT_EXP As Double = 0.002417108
    Const KAMP_EXP As Double = 0.0
    Const PTANK_EXP As Double = 0.0
    Const ABILITY_EXP As Double = 0.00313703165
    Const SETCOLLECTOR_EXP As Double = 0.0
    Const PACKRAT_EXP As Double = 0.0
    Const RAURA_EXP As Double = 0.0
    Const SCAV_EXP As Double = 0.015191871
    Const LUCK_EXP As Double = 0.0246522613
    Const QUARTER_EXP As Double = 0.0295264091
    Const ARCH_EXP As Double = 0.0688375969
    Const SPEL_EXP As Double = 0.0
    Const ASS_EXP As Double = 0.0058690916

    ' Time Values
    Const MISC_TIME As Integer = 1
    Const ADEPT_TIME As Integer = 1
    Const KAMP_TIME As Integer = 1
    Const KSH_TIME As Integer = 4
    Const PTANK_TIME As Integer = 8
    Const ABILITY_TIME As Integer = 8
    Const SETCOLLECTOR_TIME As Integer = 12
    Const PACKRAT_TIME As Integer = 12
    Const RAURA_TIME As Integer = 24
    Const SCAV_TIME As Integer = 4
    Const LUCK_TIME As Integer = 8
    Const QUARTER_TIME As Integer = 12
    Const ARCH_TIME As Integer = 24
    Const SPEL_TIME As Integer = 12
    Const ASS_TIME As Integer = 24

    ' Training Cost Modifiers
    Dim TRAINDISCOUNT() As Double = {0, 0.02, 0.04, 0.08, 0.12, 0.16, 0.2}
    Dim dblDiscount As Double

    Private Sub frmTraining_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Icon = My.Resources.icon_EHCalc_small
        Me.Location = My.Settings.trainingToolPosition

        ' Clear the form
        Clear()

        ' Load Values
        numCurrentFunds.Value = My.Settings.currentFunds
        numMiscCur.Value = My.Settings.miscPostingCur
        numMiscDes.Value = My.Settings.miscPostingDes
        numAdeptCur.Value = My.Settings.adeptLearnerCur
        numAdeptDes.Value = My.Settings.adeptLearnerDes
        numKAmpCur.Value = My.Settings.karmaAmpCur
        numKAmpDes.Value = My.Settings.karmaAmpDes
        numPTankCur.Value = My.Settings.powerTankCur
        numPTankDes.Value = My.Settings.powerTankDes
        numAbilityCur.Value = My.Settings.skillBoostCur
        numAbilityDes.Value = My.Settings.skillBoostDes
        numSCCur.Value = My.Settings.SCCur
        numSCDes.Value = My.Settings.SCDes
        numPRCur.Value = My.Settings.PRCur
        numPRDes.Value = My.Settings.PRDes
        numRAuraCur.Value = My.Settings.refinedAuraCur
        numRAuraDes.Value = My.Settings.refinedAuraDes
        numScavCur.Value = My.Settings.numScavCur
        numScavDes.Value = My.Settings.numScavDes
        numLuckCur.Value = My.Settings.numLuckCur
        numLuckDes.Value = My.Settings.numLuckDes
        numQuarterCur.Value = My.Settings.numQuarterCur
        numQuarterDes.Value = My.Settings.numQuarterDes
        numArchCur.Value = My.Settings.numArchCur
        numArchDes.Value = My.Settings.numArchDes

        numCurrentFunds.Select(0, 20)
    End Sub

    Private Sub frmTraining_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        My.Settings.trainingToolPosition = Me.Location

        My.Settings.currentFunds = numCurrentFunds.Value
        My.Settings.miscPostingCur = numMiscCur.Value
        My.Settings.miscPostingDes = numMiscDes.Value
        My.Settings.adeptLearnerCur = numAdeptCur.Value
        My.Settings.adeptLearnerDes = numAdeptDes.Value
        My.Settings.karmaAmpCur = numKAmpCur.Value
        My.Settings.karmaAmpDes = numKAmpDes.Value
        My.Settings.powerTankCur = numPTankCur.Value
        My.Settings.powerTankDes = numPTankDes.Value
        My.Settings.skillBoostCur = numAbilityCur.Value
        My.Settings.skillBoostDes = numAbilityDes.Value
        My.Settings.SCCur = numScavCur.Value
        My.Settings.SCDes = numSCDes.Value
        My.Settings.PRCur = numPRCur.Value
        My.Settings.PRDes = numPRDes.Value
        My.Settings.refinedAuraCur = numRAuraCur.Value
        My.Settings.refinedAuraDes = numRAuraDes.Value
        My.Settings.numScavCur = numScavCur.Value
        My.Settings.numScavDes = numScavDes.Value
        My.Settings.numLuckCur = numLuckCur.Value
        My.Settings.numLuckDes = numLuckDes.Value
        My.Settings.numQuarterCur = numQuarterCur.Value
        My.Settings.numQuarterDes = numQuarterDes.Value
        My.Settings.numArchCur = numArchCur.Value
        My.Settings.numArchDes = numArchDes.Value

        ' Have main window take focus
        frmMainInstance.Focus()
    End Sub

    Private Sub Clear()
        ' Rest all values to default
        txtMiscTime.Clear()
        txtMiscCost.Clear()
        numMiscCur.Value = 0
        numMiscDes.Value = 0

        txtAdeptTime.Clear()
        txtAdeptCost.Clear()
        numAdeptCur.Value = 0
        numAdeptDes.Value = 0

        txtKAmpTime.Clear()
        txtKAmpCost.Clear()
        numKAmpCur.Value = 0
        numKAmpDes.Value = 0

        txtPTankTime.Clear()
        txtPTankCost.Clear()
        numPTankCur.Value = 0
        numPTankDes.Value = 0

        txtScavTime.Clear()
        txtScavCost.Clear()
        numScavCur.Value = 0
        numScavDes.Value = 0

        txtLuckTime.Clear()
        txtLuckCost.Clear()
        numLuckCur.Value = 0
        numLuckDes.Value = 0

        txtQuarterTime.Clear()
        txtQuarterCost.Clear()
        numQuarterCur.Value = 0
        numQuarterDes.Value = 0

        txtArchTime.Clear()
        txtArchCost.Clear()
        numArchCur.Value = 0
        numArchDes.Value = 0

        txtAbilityTime.Clear()
        txtAbilityCost.Clear()
        numAbilityCur.Value = 0
        numAbilityDes.Value = 0

        txtSCTime.Clear()
        txtSCCost.Clear()
        numSCCur.Value = 0
        numSCDes.Value = 0

        txtPRTime.Clear()
        txtPRCost.Clear()
        numPRCur.Value = 0
        numPRDes.Value = 0

        txtRAuraTime.Clear()
        txtRAuraCost.Clear()
        numRAuraCur.Value = 0
        numRAuraDes.Value = 0

        txtTimeTotal.Clear()
        txtCostTotal.Clear()
    End Sub

    ' Highlight the number when we tab in
    Private Sub TrainingLevelNumber_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numRAuraDes.Enter, numAbilityDes.Enter, _
    numPTankDes.Enter, numKAmpDes.Enter, numAdeptDes.Enter, _
    numRAuraCur.Enter, numAbilityCur.Enter, numPTankCur.Enter, _
    numKAmpCur.Enter, numAdeptCur.Enter, numPRCur.Enter, numPRDes.Enter, numScavCur.Enter, numScavDes.Enter, numLuckCur.Enter, numLuckDes.Enter, _
    numQuarterCur.Enter, numQuarterDes.Enter, numArchCur.Enter, numArchDes.Enter, numSCCur.Enter, numSCDes.Enter
        Dim newSender As Windows.Forms.NumericUpDown = CType(sender, Windows.Forms.NumericUpDown)
        newSender.Select(0, 4)
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Dim result As DialogResult

        result = MessageBox.Show("Are you sure you want to clear?", "EH Calculator", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

        If result = Windows.Forms.DialogResult.Yes Then
            Clear()
        End If
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub Calculate()
        Dim intCur, intDes, intTime, intTotalTime, intCost As Integer
        Dim intRemainingFunds, intCurrentFunds, intTotalCost As Integer
        ' Just incase ALL training items are invalid.
        intTotalCost = 0
        intTotalTime = 0
        intCurrentFunds = CInt(numCurrentFunds.Value)
        ' Do we get any discount?
        dblDiscount = TRAINDISCOUNT(My.Settings.creditPerk)


        ' Go down the list, calculate costs
        intCur = CInt(numMiscCur.Value)
        intDes = CInt(numMiscDes.Value)
        ' Must have a valid desired level!
        If intDes > intCur Then
            'Calculate
            intCost = Cost(MISC_BASE, MISC_COST, MISC_EXP, intCur, intDes)
            intTime = (intDes - intCur) * ABILITY_TIME
            ' Update Display
            txtMiscCost.Text = intCost.ToString("#,#")
            txtMiscTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtMiscCost.Text = ""
            txtMiscTime.Text = ""
        End If

        intCur = CInt(numAdeptCur.Value)
        intDes = CInt(numAdeptDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(ADEPT_BASE, ADEPT_COST, ADEPT_EXP, intCur, intDes)
            intTime = (intDes - intCur) * ADEPT_TIME
            ' Update Display
            txtAdeptCost.Text = intCost.ToString("#,#")
            txtAdeptTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtAdeptCost.Text = ""
            txtAdeptTime.Text = ""
        End If

        intCur = CInt(numAssimilatorCur.Value)
        intDes = CInt(numAssimilatorDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(ASS_BASE, ASS_COST, ASS_EXP, intCur, intDes)
            intTime = (intDes - intCur) * ASS_TIME
            ' Update Display
            txtAssimilatorCost.Text = intCost.ToString("#,#")
            txtAssimilatorTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtAssimilatorCost.Text = ""
            txtAssimilatorTime.Text = ""
        End If

        intCur = CInt(numKAmpCur.Value)
        intDes = CInt(numKAmpDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(KAMP_BASE, KAMP_COST, KAMP_EXP, intCur, intDes)
            intTime = (intDes - intCur) * KAMP_TIME
            ' Update Display
            txtKAmpCost.Text = intCost.ToString("#,#")
            txtKAmpTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtKAmpCost.Text = ""
            txtKAmpTime.Text = ""
        End If

        intCur = CInt(numSCCur.Value)
        intDes = CInt(numSCDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(SETCOLLECTOR_BASE, SETCOLLECTOR_COST, SETCOLLECTOR_EXP, intCur, intDes)
            intTime = (intDes - intCur) * SETCOLLECTOR_TIME
            ' Update Display
            txtSCCost.Text = intCost.ToString("#,#")
            txtSCTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtSCCost.Text = ""
            txtSCTime.Text = ""
        End If

        intCur = CInt(numPTankCur.Value)
        intDes = CInt(numPTankDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(PTANK_BASE, PTANK_COST, PTANK_EXP, intCur, intDes)
            intTime = (intDes - intCur) * PTANK_TIME
            ' Update Display
            txtPTankCost.Text = intCost.ToString("#,#")
            txtPTankTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtPTankCost.Text = ""
            txtPTankTime.Text = ""
        End If

        intCur = CInt(numScavCur.Value)
        intDes = CInt(numScavDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(SCAV_BASE, SCAV_COST, SCAV_EXP, intCur, intDes)
            intTime = (intDes - intCur) * SCAV_TIME
            ' Update Display
            txtScavCost.Text = intCost.ToString("#,#")
            txtScavTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtScavCost.Text = ""
            txtScavTime.Text = ""
        End If

        intCur = CInt(numLuckCur.Value)
        intDes = CInt(numLuckDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(LUCK_BASE, LUCK_COST, LUCK_EXP, intCur, intDes)
            intTime = (intDes - intCur) * LUCK_TIME
            ' Update Display
            txtLuckCost.Text = intCost.ToString("#,#")
            txtLuckTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtLuckCost.Text = ""
            txtLuckTime.Text = ""
        End If

        intCur = CInt(numQuarterCur.Value)
        intDes = CInt(numQuarterDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(QUARTER_BASE, QUARTER_COST, QUARTER_EXP, intCur, intDes)
            intTime = (intDes - intCur) * QUARTER_TIME
            ' Update Display
            txtQuarterCost.Text = intCost.ToString("#,#")
            txtQuarterTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtQuarterCost.Text = ""
            txtQuarterTime.Text = ""
        End If

        intCur = CInt(numArchCur.Value)
        intDes = CInt(numArchDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(ARCH_BASE, ARCH_COST, ARCH_EXP, intCur, intDes)
            intTime = (intDes - intCur) * ARCH_TIME
            ' Update Display
            txtArchCost.Text = intCost.ToString("#,#")
            txtArchTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtArchCost.Text = ""
            txtArchTime.Text = ""
        End If

        intCur = CInt(numAbilityCur.Value)
        intDes = CInt(numAbilityDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(ABILITY_BASE, ABILITY_COST, ABILITY_EXP, intCur, intDes)
            intTime = (intDes - intCur) * ABILITY_TIME
            ' Update Display
            txtAbilityCost.Text = intCost.ToString("#,#")
            txtAbilityTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtAbilityCost.Text = ""
            txtAbilityTime.Text = ""
        End If

        intCur = CInt(numSpelunkerCur.Value)
        intDes = CInt(numSpelunkerDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(SPEL_BASE, SPEL_COST, SPEL_EXP, intCur, intDes)
            intTime = (intDes - intCur) * SPEL_TIME
            ' Update Display
            txtSpelunkerCost.Text = intCost.ToString("#,#")
            txtSpelunkerTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtSpelunkerCost.Text = ""
            txtSpelunkerTime.Text = ""
        End If

        intCur = CInt(numPRCur.Value)
        intDes = CInt(numPRDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(PACKRAT_BASE, PACKRAT_COST, PACKRAT_EXP, intCur, intDes)
            intTime = (intDes - intCur) * PACKRAT_TIME
            ' Update Display
            txtPRCost.Text = intCost.ToString("#,#")
            txtPRTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtPRCost.Text = ""
            txtPRTime.Text = ""
        End If

        intCur = CInt(numRAuraCur.Value)
        intDes = CInt(numRAuraDes.Value)
        ' Must have a valid Desired Level!
        If intDes > intCur Then
            ' Calculate
            intCost = Cost(RAURA_BASE, RAURA_COST, RAURA_EXP, intCur, intDes)
            intTime = (intDes - intCur) * RAURA_TIME
            ' Update Display
            txtRAuraCost.Text = intCost.ToString("#,#")
            txtRAuraTime.Text = intTime.ToString
            ' Update Total
            intTotalCost += intCost
            intTotalTime += intTime
        Else
            txtRAuraCost.Text = ""
            txtRAuraTime.Text = ""
        End If

        intRemainingFunds = intCurrentFunds - intTotalCost

        ' Display Total
        txtCostTotal.Text = intTotalCost.ToString("#,#")
        txtTimeTotal.Text = intTotalTime.ToString("#,#")
        txtRemainingFunds.Text = intRemainingFunds.ToString("#,#")
    End Sub

    ' Function Cost
    ' Returns an interger repesenting the cost of training a particular training item
    ' -Parameters-
    '  basecost (integer): The initial base cost of the training item
    '  levelcost (integer): The cost to go up one level
    '  exp (double): The exponential value used to create a dynamic cost curve (Making it more expensive the higher you go)
    '  startlvl (integer): Level to start training on
    '  stoplvl (integer): Level to stop training on
    Private Function Cost(ByVal basecost As Integer, ByVal levelcost As Integer, ByVal exp As Double, ByVal startlvl As Integer, ByVal stoplvl As Integer) As Integer
        Dim total, i As Integer
        total = 0
        i = startlvl

        Do While i < stoplvl
            total += CInt(Math.Round(Math.Pow(basecost + levelcost * i, 1 + exp * i) * (1 - dblDiscount), MidpointRounding.AwayFromZero))
            i += 1
        Loop

        Return total
    End Function

#Region "Clear Buttons"
    Private Sub btnClearMisc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearMisc.Click
        txtMiscTime.Clear()
        txtMiscCost.Clear()
        numMiscCur.Value = 0
        numMiscDes.Value = 0
    End Sub

    Private Sub btnClearAL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAL.Click
        txtAdeptTime.Clear()
        txtAdeptCost.Clear()
        numAdeptCur.Value = 0
        numAdeptDes.Value = 0
    End Sub

    Private Sub btnClearKA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearKA.Click
        txtKAmpTime.Clear()
        txtKAmpCost.Clear()
        numKAmpCur.Value = 0
        numKAmpDes.Value = 0
    End Sub

    Private Sub btnClearPT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearPT.Click
        txtPTankTime.Clear()
        txtPTankCost.Clear()
        numPTankCur.Value = 0
        numPTankDes.Value = 0
    End Sub

    Private Sub btnClearAB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAB.Click
        txtAbilityTime.Clear()
        txtAbilityCost.Clear()
        numAbilityCur.Value = 0
        numAbilityDes.Value = 0
    End Sub

    Private Sub btnClearSC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearSC.Click
        txtSCTime.Clear()
        txtSCCost.Clear()
        numSCCur.Value = 0
        numSCDes.Value = 0
    End Sub

    Private Sub btnClearPRat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearPRat.Click
        txtPRTime.Clear()
        txtPRCost.Clear()
        numPRCur.Value = 0
        numPRDes.Value = 0
    End Sub

    Private Sub btnClearRA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearRA.Click
        txtRAuraTime.Clear()
        txtRAuraCost.Clear()
        numRAuraCur.Value = 0
        numRAuraDes.Value = 0
    End Sub

    Private Sub btnClearTotal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearTotal.Click
        txtTimeTotal.Clear()
        txtCostTotal.Clear()
    End Sub

    Private Sub btnClearScav_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearScav.Click
        txtScavTime.Clear()
        txtScavCost.Clear()
        numScavCur.Value = 0
        numScavDes.Value = 0
    End Sub

    Private Sub btnClearLuck_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearLuck.Click
        txtLuckTime.Clear()
        txtLuckCost.Clear()
        numLuckCur.Value = 0
        numLuckDes.Value = 0
    End Sub

    Private Sub numQuarterClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuarterClear.Click
        txtQuarterTime.Clear()
        txtQuarterCost.Clear()
        numQuarterCur.Value = 0
        numQuarterDes.Value = 0
    End Sub

    Private Sub numArchClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnArchClear.Click
        txtArchTime.Clear()
        txtArchCost.Clear()
        numArchCur.Value = 0
        numArchDes.Value = 0
    End Sub

    Private Sub btnClearAssimilator_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAssimilator.Click
        txtAssimilatorTime.Clear()
        txtAssimilatorCost.Clear()
        numAssimilatorCur.Value = 0
        numAssimilatorDes.Value = 0
    End Sub

    Private Sub btnClearSpelunker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearSpelunker.Click
        txtSpelunkerTime.Clear()
        txtSpelunkerCost.Clear()
        numSpelunkerCur.Value = 0
        numSpelunkerDes.Value = 0
    End Sub
#End Region

#Region "Training Lvl Value Check"
    ' Don't allow current to exceed desire
    ' Also, calculate when values change
    Private Sub numMiscCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numMiscCur.ValueChanged
        If numMiscCur.Value > numMiscDes.Value Then
            numMiscCur.Value = numMiscCur.Value
            numMiscDes.Select(0, 6)
        Else ' Otherwise, if we are changing the Desire or vise versa, we will end up calculating twice!
            Calculate()
        End If
    End Sub

    Private Sub numAdeptCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAdeptCur.ValueChanged
        If numAdeptCur.Value > numAdeptDes.Value Then
            numAdeptDes.Value = numAdeptCur.Value
            numAdeptDes.Select(0, 6)
        Else ' Otherwise, if we are changing the Desire or vise versa, we will end up calculating twice!
            Calculate()
        End If
    End Sub

    Private Sub numAssimilatorCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAssimilatorCur.ValueChanged
        If numAssimilatorCur.Value > numAssimilatorDes.Value Then
            numAssimilatorDes.Value = numAssimilatorCur.Value
            numAssimilatorDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numKAmpCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numKAmpCur.ValueChanged
        If numKAmpCur.Value > numKAmpDes.Value Then
            numKAmpDes.Value = numKAmpCur.Value
            numKAmpDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numSCCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numSCCur.ValueChanged
        If numSCCur.Value > numSCDes.Value Then
            numSCDes.Value = numSCCur.Value
            numSCDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numPTankCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numPTankCur.ValueChanged
        If numPTankCur.Value > numPTankDes.Value Then
            numPTankDes.Value = numPTankCur.Value
            numPTankDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numScavCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numScavCur.ValueChanged
        If numScavCur.Value > numScavDes.Value Then
            numScavDes.Value = numScavCur.Value
            numScavDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numLuckCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numLuckCur.ValueChanged
        If numLuckCur.Value > numLuckDes.Value Then
            numLuckDes.Value = numLuckCur.Value
            numLuckDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numQuarterCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numQuarterCur.ValueChanged
        If numQuarterCur.Value > numQuarterDes.Value Then
            numQuarterDes.Value = numQuarterCur.Value
            numQuarterDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numArchCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numArchCur.ValueChanged
        If numArchCur.Value > numArchDes.Value Then
            numArchDes.Value = numArchCur.Value
            numArchDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numAbilityCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAbilityCur.ValueChanged
        If numAbilityCur.Value > numAbilityDes.Value Then
            numAbilityDes.Value = numAbilityCur.Value
            numAbilityDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numSpelunker_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numSpelunkerCur.ValueChanged
        If numSpelunkerCur.Value > numSpelunkerDes.Value Then
            numSpelunkerDes.Value = numSpelunkerCur.Value
            numSpelunkerDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numPRCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numPRCur.ValueChanged
        If numPRCur.Value > numPRDes.Value Then
            numPRDes.Value = numPRCur.Value
            numPRDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numRAuraCur_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numRAuraCur.ValueChanged
        If numRAuraCur.Value > numRAuraDes.Value Then
            numRAuraDes.Value = numRAuraCur.Value
            numRAuraDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    ' Unlike the 'current' numbers, we will refuse to let Desire go below current by resetting desire to equal current
    Private Sub numMiscDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numMiscDes.ValueChanged
        If numMiscCur.Value > numMiscDes.Value Then
            numMiscDes.Value = numMiscCur.Value
            numMiscDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numAdeptDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAdeptDes.ValueChanged
        If numAdeptCur.Value > numAdeptDes.Value Then
            numAdeptDes.Value = numAdeptCur.Value
            numAdeptDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numAssimilatorDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAssimilatorDes.ValueChanged
        If numAssimilatorCur.Value > numAssimilatorDes.Value Then
            numAssimilatorDes.Value = numAssimilatorCur.Value
            numAssimilatorDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numKAmpDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numKAmpDes.ValueChanged
        If numKAmpCur.Value > numKAmpDes.Value Then
            numKAmpDes.Value = numKAmpCur.Value
            numKAmpDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numSCDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numSCDes.ValueChanged
        If numSCCur.Value > numSCDes.Value Then
            numSCDes.Value = numSCCur.Value
            numSCDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numPTankDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numPTankDes.ValueChanged
        If numPTankCur.Value > numPTankDes.Value Then
            numPTankDes.Value = numPTankCur.Value
            numPTankDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numScavDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numScavDes.ValueChanged
        If numScavCur.Value > numScavDes.Value Then
            numScavDes.Value = numScavCur.Value
            numScavDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numLuckDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numLuckDes.ValueChanged
        If numLuckCur.Value > numLuckDes.Value Then
            numLuckDes.Value = numLuckCur.Value
            numLuckDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numQuarterDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numQuarterDes.ValueChanged
        If numQuarterCur.Value > numQuarterDes.Value Then
            numQuarterDes.Value = numQuarterCur.Value
            numQuarterDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numArchDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numArchDes.ValueChanged
        If numArchCur.Value > numArchDes.Value Then
            numArchDes.Value = numArchCur.Value
            numArchDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numAbilityDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numAbilityDes.ValueChanged
        If numAbilityCur.Value > numAbilityDes.Value Then
            numAbilityDes.Value = numAbilityCur.Value
            numAbilityDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numSpelunkerDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numSpelunkerDes.ValueChanged
        If numSpelunkerCur.Value > numSpelunkerDes.Value Then
            numSpelunkerDes.Value = numSpelunkerCur.Value
            numSpelunkerDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numPRDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numPRDes.ValueChanged
        If numPRCur.Value > numPRDes.Value Then
            numPRDes.Value = numPRCur.Value
            numPRDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub

    Private Sub numRAuraDes_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numRAuraDes.ValueChanged
        If numRAuraCur.Value > numRAuraDes.Value Then
            numRAuraDes.Value = numRAuraCur.Value
            numRAuraDes.Select(0, 6)
        Else
            Calculate()
        End If
    End Sub


    Private Sub numCurrentFunds_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numCurrentFunds.ValueChanged
        Calculate()
    End Sub
#End Region

End Class